INCLUDE "STANDARD.BI"
INCLUDE "VERAPCM.BI"

DIM loop_ctr1 AS BYTE FAST
DIM PlayDone AS BYTE
DIM PCM_CFG_VAR AS BYTE
DIM PCM_VOLUME AS BYTE
DIM PCM_V_RATE AS BYTE
DIM SCRATCHBANK AS BYTE
DIM IsStereo AS BYTE
DIM IsSupported AS BYTE
DIM SampleRate AS LONG
DIM Is_Host_FS AS BYTE
DIM PCM_LFN AS BYTE FAST
DIM BLength AS BYTE FAST
DIM I AS BYTE FAST
DIM C AS BYTE FAST
DIM FSCNT AS BYTE FAST
DIM RIFFHDR AS STRING * 44 @$A000
DIM AUDIO_FILE AS STRING * 96
DIM _Key AS BYTE FAST
DIM _MX AS WORD @R14
DIM _MY AS WORD @R15
DIM _MWHEEL AS INT 
DIM Byte_Rate AS FLOAT FAST
DIM Jifs AS LONG
DIM Mins AS LONG
DIM Secs AS LONG


SUB TEST_FILESYSTEM()
  PRINT "{WHITE}Testing File System{GREEN}:{LIGHT GREEN} ";
  AUDIOFILE = "test.f"
  IF NOT FILEEXISTS(AUDIOFILE,8) THEN
    OPEN 2,8,2,"@:test.f,s,w"
    FOR I = 1 TO 60
      PRINT #2, "abcdefghijklmnopqrstuvwxyz"
      PRINT ".";
    NEXT I
    CLOSE 2
  END IF
  OPEN 2,8,2,"test.f,s,r"
  ASM
   ldx {SCRATCHBANK}
   stx 0
   ldx #2
   jsr {CHKIN}
   ldx #0
   ldy #$A0
   lda #0
   clc
   jsr {MACPTR}
   sty {Is_Host_FS}
   jsr {CLRCHN}
  END ASM
  CLOSE 2
  If Is_Host_FS=1 THEN Is_Host_FS=$FF
  If Is_Host_FS=2 THEN Is_Host_FS=0
  If Is_Host_FS THEN PRINT "{YELLOW}HOST FILE SYSTEM{WHITE}" ELSE PRINT "{LIGHT_RED}SD CARD FOUND{WHITE}"
END SUB

SUB OpenZCM(ZCMFILE AS STRING*96) STATIC
   OPEN PCM_LFN,8,PCM_LFN,ZCMFILE+",s,r"
   ASM
    lda {SCRATCHBANK}
    sta 0
    ldx {PCM_LFN}
    jsr {CHKIN}
    ldx #$01
    ldy #$A0
    lda #8
    sta {RIFFHDR}
    jsr {MACPTR}
    jsr {CLRCHN}
  END ASM
  PCM_V_RATE = ASC(MID$(RIFFHDR,7,1))
  PCM_CFG_VAR = ASC(MID$(RIFFHDR,6,1))
  Byte_Rate = PCM_V_RATE * 381
  PCM_CFG_VAR = PCM_CFG_VAR AND %11110000
  PCM_CFG_VAR = PCM_CFG_VAR OR PCM_VOLUME
END SUB


FUNCTION OpenWav AS BYTE(WAVFILE AS STRING*96) STATIC
 DIM IsWave AS BYTE
 DIM IsPCM AS BYTE
 DIM PCMBits AS BYTE
 DIM TMP1 AS WORD
 DIM TMP2 AS WORD
 DIM TMP3 AS LONG
 DIM TMP4 AS WORD
   OPEN PCM_LFN,8,PCM_LFN,WAVFILE+",s,r"
   ASM
    lda {SCRATCHBANK}
    sta 0
    lda #44
    sta {RIFFHDR}
    ldx {PCM_LFN}
    jsr {CHKIN}
    ldx #$01
    ldy #$A0
    lda #44
    jsr {MACPTR}
    jsr {CLRCHN}
  END ASM
  IsWave = (LEFT$(RIFFHDR,4) = "riff") AND (MID$(RIFFHDR,8,4)="wave")
  PCMBits = ASC(MID$(RIFFHDR,34,1))
  TMP1 = ASC(MID$(RIFFHDR,20,1))
  TMP2 = ASC(MID$(RIFFHDR,21,1))
  TMP4 = CWORD(TMP1) + CWORD(256*TMP2)
  IsPCM = (TMP4=1)
  TMP1 = ASC(MID$(RIFFHDR,24,1))
  TMP2 = CWORD(ASC(MID$(RIFFHDR,25,1))) * 256
  TMP3 = CLONG(ASC(MID$(RIFFHDR,26,1)) * 65536)
  SampleRate = TMP1+TMP2+TMP3
  NumChannels = ASC(MID$(RIFFHDR,22,1))
  IsStereo = (NumChannels=2)
  IsSupported = (IsWave AND (PCMBits=16)) AND IsPCM AND ((NumChannels > 0) AND (NumChannels < 3))

  IF IsSupported THEN 
     PCM_V_RATE=CBYTE(CALC_VERA_RATE(SampleRate))
     PCM_CFG_VAR = BIT16_ON
     IF IsStereo THEN PCM_CFG_VAR = (PCM_CFG_VAR OR STEREO_ON)
     PCM_CFG_VAR = (PCM_CFG_VAR OR PCM_VOLUME)
  END IF

  IF NOT IsSupported THEN CLOSE PCM_LFN
  RETURN IsSupported
END FUNCTION

SUB FILL_AUDIO_FIFO() static
    ASM
      ldx {PCM_LFN}
      jsr {CHKIN}
      ldx #17
      sta {loop_ctr1}
loop  ldx #$3D
      ldy #$9f
      lda #240
      sec
      jsr {MACPTR}
      jsr {READST}
      bne done
      dec {loop_ctr1}
      bne loop
      clc
      bcc fend
done  lda $FF
      sta {PlayDone}
fend  jsr {CLRCHN}
    END ASM
END SUB


SUB TWEAK_AUDIO_FIFO() static
    ASM
      ldx {PCM_LFN}
      jsr {CHKIN}
      ldx {FSCNT}
      stx {loop_ctr1}
loop2 ldx #$3D
      ldy #$9f
      lda #0
      sec
      jsr {MACPTR}
      jsr {READST}
      bne done2
      dec {loop_ctr1}
      bne loop2
      jmp fend2
done2 lda $FF
      sta {PlayDone}
fend2 jsr {CLRCHN}
    END ASM
END SUB

SUB PausePCMStream() STATIC
  POKE AUDIO_RATE, 0
  LOCATE 2,5
  PRINT "{1}** Play Paused **{1}";
  BLength=19
kloop:
  GET _Key
  IF _Key<> 32 AND _Key<>27 THEN GOTO kloop
  POKE AUDIO_RATE, PCM_V_RATE
END SUB

SUB PCM_SetVolume() STATIC
 DIM TMPB AS BYTE
 TMPB = PCM_CFG_VAR AND %11110000
 PCM_CFG_VAR = TMPB OR PCM_VOLUME
 POKE AUDIO_CTRL, PCM_CFG_VAR
END SUB

SUB VolumeDown() Static
 IF PCM_VOLUME > 1 THEN
    PCM_VOLUME=PCM_VOLUME-1
    CALL PCM_SetVolume()
 END IF
END SUB

SUB VolumeUp() Static
 IF PCM_VOLUME < 15 Then
    PCM_VOLUME = PCM_VOLUME+1
    CALL PCM_SetVolume()
 END IF
END SUB

SUB PlayPCMStream() STATIC
   PRINT "{BLUE}";CHR$(1);"{WHITE}";
   LOCATE 0,5
   PlayDone = 0
   BLength = 0
   IF Is_Host_FS THEN FSCNT = 12 ELSE FSCNT=6
   IF Byte_Rate > 80000.0 THEN FSCNT = FSCNT + 1
   IF Byte_Rate > 100000.0 THEN FSCNT = FSCNT + 1
   POKE AUDIO_RATE, 0
   POKE AUDIO_CTRL, PCM_CFG_VAR
   CALL FILL_AUDIO_FIFO()
   CALL ZeroTimer()
   POKE AUDIO_RATE, PCM_V_RATE
PLAYLOOP:
   IF PlayDone THEN GOTO DONELOOP
   IF (VERA_ISR AND AFLOW_ON) = AFLOW_ON THEN
     CALL TWEAK_AUDIO_FIFO()
     PRINT "*";
     BLength = BLength + 1
   END IF
   GET _Key
   IF _Key > 0 THEN
      IF _Key = 27 THEN PlayDone = TRUE
      IF _Key = 32 THEN Call PausePCMStream()
      IF _Key = 145 THEN Call VolumeUp()
      IF _Key = 17 THEN Call VolumeDown()
   END IF
   If Blength = 80 then
      PRINT "{1}";
      LOCATE 0,5
      BLength = 0
   END IF
   GOTO PLAYLOOP
DONELOOP:
   PRINT "{BLACK}";CHR$(1);"{WHITE}"
END SUB

SCRATCHBANK = 63
PCM_LFN = 6
PCM_VOLUME = 10


PRINT CHR$($0E)
PRINT "{BLACK}"
PRINT CHR$(01)
PRINT "{WHITE}"
PRINT "{CLR}"
CALL TEST_FILESYSTEM()
TRYAGAIN:
LOCATE 0,13
PRINT " {WHITE}Enter [{LIGHT_GREEN}EXIT{WHITE}] to {YELLOW}End {WHITE}program."
PRINT "                                                      "
PRINT " Enter {LIGHT_GREEN}AUDIO{WHITE} file name {LIGHT_GRAY}({YELLOW}ZCM{WHITE} or{YELLOW} WAV{LIGHT_GRAY}){WHITE} "
INPUT "{LIGHT_GREEN} =={YELLOW}>{GREEN}";AUDIO_FILE
PRINT "{WHITE}"
AUDIO_FILE = ASCII_UPPER(AUDIO_FILE)

IF AUDIO_FILE = "exit" THEN END

IF NOT (FILEEXISTS(AUDIO_FILE,8)) THEN
   PRINT " {LIGHT_RED}";AUDIO_FILE;"{YELLOW} does not exist {LIGHT_RED}!"
   PRINT ""
   GOTO TRYAGAIN
END IF

IF FILE_EXTENSION(AUDIO_FILE) = "zcm" THEN
   GOSUB StartDisplay
   PRINT "{WHITE} Playing{LIGHT_GREEN} ZCM{WHITE} :{GREEN}";AUDIO_FILE;"{WHITE}"
   CALL OpenZCM(AUDIO_FILE)
   CALL PlayPCMStream()
   GOTO CLEANUP
END IF

If OpenWAV(AUDIO_FILE) THEN
   GOSUB StartDisplay
   PRINT " {WHITE}Playing {LIGHT_GREEN}WAV {WHITE}:{GREEN}";AUDIO_FILE;"{WHITE}"
   CALL PlayPCMStream()
   GOTO CLEANUP 
END IF
  PRINT ""
  PRINT "{LIGHT_RED} WAV File Error or Not supported {YELLOW}!"
  PRINT ""
  GOTO TRYAGAIN


CLEANUP:
 CLOSE PCM_LFN
WAITCLR:
 IF NOT FIFO_Is_Empty() THEN GOTO WAITCLR
 PRINT "{CLR}"
 LOCATE 0, 5
 PRINT " {WHITE}";AUDIO_FILE;" {GREEN}Done {LIGHT_GREEN}!{13}"
 Jifs = READTIM()
 Secs = Jifs / 60
 Mins = Secs / 60
 Jifs = Jifs - (Secs*60)
 Secs = Secs - (Mins*60)

 PRINT " {WHITE}";Mins;" {LIGHT_GRAY}Minute";
 IF Mins>1 or Mins=0 THEN PRINT "s, {WHITE}"; ELSE PRINT ", {WHITE}";
 PRINT Secs;" {LIGHT_GRAY}Second";
 IF Secs>1 or Secs=0 THEN PRINT "s, {WHITE}"; ELSE PRINT ", {WHITE}";
 PRINT Jifs;
 IF Jifs = 0 or Jifs>1 THEN PRINT " {LIGHT_GRAY}Jiffies{WHITE}" ELSE PRINT " {LIGHT_GRAY}Jiffy{WHITE}"

 GOTO TRYAGAIN
 END

StartDisplay:
 DIM AUDIO_hz as FLOAT
 AUDIO_hz=(PCM_V_RATE/128.0) * 48828.15
 Byte_Rate = AUDIO_hz
 PRINT "{CLR}"
 LOCATE 0,10
 IF (PCM_CFG_VAR AND BIT16_ON) = BIT16_ON THEN
    PRINT "  16 bit File":PRINT ""
    Byte_Rate = Byte_Rate*2.0
 END IF
 IF (PCM_CFG_VAR AND STEREO_ON) = STEREO_ON THEN PRINT "  Stereo Stream" ELSE PRINT "  Single Channel Stream"
 IF (PCM_CFG_VAR AND STEREO_ON) = STEREO_ON THEN Byte_Rate = Byte_Rate*2.0
 PRINT "":PRINT ""
 PRINT "  Rate Byte: {LIGHT_GREEN}";PCM_V_RATE
 PRINT ""
 PRINT "  {WHITE}Digital playback rate:{LIGHT_GREEN} ";AUDIO_hz;"{GREEN}hz"
 PRINT ""
 PRINT "{WHITE}  Byte Rate: {LIGHT_GREEN}";CLONG(Byte_Rate+0.5);"{GREEN}  Bytes{YELLOW}/{GREEN}Second"
 PRINT "":PRINT ""
 PRINT "{GREEN} [{YELLOW}Space Bar{GREEN}]{WHITE} to pause play{LIGHT_GRAY}.  {GREEN}[{YELLOW}ESC{GREEN}]{WHITE} Ends play{LIGHT_GRAY}."
 LOCATE 0,2
 RETURN

ADJUST_ADDER:
IF PCM_V_RATE > 80 THEN IF Is_Host_FS THEN FSCNT=FSCNT+2 ELSE FSCNT=FSCNT+1
IF PCM_V_RATE > 110 THEN  IF Is_Host_FS THEN FSCNT=FSCNT + 4 ELSE FSCNT=FSCNT+2
RETURN



