SHARED CONST PCM_fifo = $9F3D
SHARED CONST AUDIO_CTRL = $9F3B
SHARED CONST AUDIO_RATE = $9F3C
SHARED CONST STEREO_ON  = %00010000
SHARED CONST STEREO_OFF = %11101111
SHARED CONST BIT16_ON = %00100000
SHARED CONST FIFO_EMPTY = %01000000
SHARED CONST FIFO_FULL = %10000000
SHARED CONST VERA_IEN = $9F26
SHARED CONST AFLOW_ON = %00001000

DIM SHARED CTRL AS BYTE @$9F3B
DIM SHARED FIFO AS BYTE @$9F3D
DIM SHARED VERA_IEN AS BYTE @$9F26
DIM SHARED VERA_ISR AS BYTE @$9F27

FUNCTION FIFO_LOW AS BYTE() STATIC SHARED
 RETURN (VERA_ISR AND AFLOW_ON) = AFLOW_ON
END FUNCTION

FUNCTION FIFO_Is_FULL AS BYTE() STATIC SHARED
 RETURN (CTRL AND FIFO_FULL) = FIFO_FULL
END FUNCTION

FUNCTION FIFO_Is_Empty AS BYTE() STATIC SHARED
 RETURN (CTRL AND FIFO_EMPTY) = FIFO_EMPTY
END FUNCTION

FUNCTION CALC_VERA_RATE AS LONG(TRUERATE AS LONG) STATIC SHARED
 RETURN TRUERATE / CLONG(380)
END FUNCTION
